require 'rails/generators'
require 'rails/generators/active_record'

module EtHistory
  class InstallGenerator < ::Rails::Generators::Base
    include ::Rails::Generators::Migration

    source_root File.expand_path('../templates', __FILE__)

    desc 'Adds papertrail migration, controller, and view'

    def create_migration_file
      migration_template 'create_versions.rb', 'db/migrate/create_versions.rb'
    end

    def create_controller_file
      template('history_controller.rb', "app/controllers/history_controller.rb")
    end

    def create_view_file
      directory('history/', 'app/views/history')
      # template('history_index.html.erb', "app/views/history/index.html.erb")
    end

    def create_model_file
      template('version.rb', "app/models/version.rb")
    end

    def create_initializer
      template('paper_trail.rb', "config/initializers/paper_trail.rb")
    end


    def create_routes_entry
      route 'resources :history, only: :index'
    end

    def self.next_migration_number(dirname)
      ::ActiveRecord::Generators::Base.next_migration_number(dirname)
    end
  end
end
